#ifndef _H_B75235FD876533DF3524DBB137AC8698_AutoDocking_DCPS_H_
#define _H_B75235FD876533DF3524DBB137AC8698_AutoDocking_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AutoDocking_.h"


namespace kobuki_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            class AutoDocking_Goal_TypeSupportInterface;

            typedef AutoDocking_Goal_TypeSupportInterface * AutoDocking_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Goal_TypeSupportInterface> AutoDocking_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Goal_TypeSupportInterface> AutoDocking_Goal_TypeSupportInterface_out;


            class AutoDocking_Goal_DataWriter;

            typedef AutoDocking_Goal_DataWriter * AutoDocking_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Goal_DataWriter> AutoDocking_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Goal_DataWriter> AutoDocking_Goal_DataWriter_out;


            class AutoDocking_Goal_DataReader;

            typedef AutoDocking_Goal_DataReader * AutoDocking_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Goal_DataReader> AutoDocking_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Goal_DataReader> AutoDocking_Goal_DataReader_out;


            class AutoDocking_Goal_DataReaderView;

            typedef AutoDocking_Goal_DataReaderView * AutoDocking_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Goal_DataReaderView> AutoDocking_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Goal_DataReaderView> AutoDocking_Goal_DataReaderView_out;

            struct AutoDocking_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AutoDocking_Goal_, struct AutoDocking_Goal_Seq_uniq_> AutoDocking_Goal_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_Goal_Seq> AutoDocking_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_Goal_Seq> AutoDocking_Goal_Seq_out;

            class  AutoDocking_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_Goal_TypeSupportInterface_var _var_type;

                static AutoDocking_Goal_TypeSupportInterface_ptr _duplicate (AutoDocking_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_Goal_TypeSupportInterface () {};
                ~AutoDocking_Goal_TypeSupportInterface () {};
            private:
                AutoDocking_Goal_TypeSupportInterface (const AutoDocking_Goal_TypeSupportInterface &);
                AutoDocking_Goal_TypeSupportInterface & operator = (const AutoDocking_Goal_TypeSupportInterface &);
            };

            class  AutoDocking_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_Goal_DataWriter_ptr _ptr_type;
                typedef AutoDocking_Goal_DataWriter_var _var_type;

                static AutoDocking_Goal_DataWriter_ptr _duplicate (AutoDocking_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Goal_& instance_data) = 0;

            protected:
                AutoDocking_Goal_DataWriter () {};
                ~AutoDocking_Goal_DataWriter () {};
            private:
                AutoDocking_Goal_DataWriter (const AutoDocking_Goal_DataWriter &);
                AutoDocking_Goal_DataWriter & operator = (const AutoDocking_Goal_DataWriter &);
            };

            class  AutoDocking_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_Goal_DataReader_ptr _ptr_type;
                typedef AutoDocking_Goal_DataReader_var _var_type;

                static AutoDocking_Goal_DataReader_ptr _duplicate (AutoDocking_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Goal_& instance) = 0;

            protected:
                AutoDocking_Goal_DataReader () {};
                ~AutoDocking_Goal_DataReader () {};
            private:
                AutoDocking_Goal_DataReader (const AutoDocking_Goal_DataReader &);
                AutoDocking_Goal_DataReader & operator = (const AutoDocking_Goal_DataReader &);
            };

            class  AutoDocking_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_Goal_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_Goal_DataReaderView_var _var_type;

                static AutoDocking_Goal_DataReaderView_ptr _duplicate (AutoDocking_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Goal_& instance) = 0;

            protected:
                AutoDocking_Goal_DataReaderView () {};
                ~AutoDocking_Goal_DataReaderView () {};
            private:
                AutoDocking_Goal_DataReaderView (const AutoDocking_Goal_DataReaderView &);
                AutoDocking_Goal_DataReaderView & operator = (const AutoDocking_Goal_DataReaderView &);
            };
            class AutoDocking_SendGoal_Request_TypeSupportInterface;

            typedef AutoDocking_SendGoal_Request_TypeSupportInterface * AutoDocking_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Request_TypeSupportInterface> AutoDocking_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Request_TypeSupportInterface> AutoDocking_SendGoal_Request_TypeSupportInterface_out;


            class AutoDocking_SendGoal_Request_DataWriter;

            typedef AutoDocking_SendGoal_Request_DataWriter * AutoDocking_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Request_DataWriter> AutoDocking_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Request_DataWriter> AutoDocking_SendGoal_Request_DataWriter_out;


            class AutoDocking_SendGoal_Request_DataReader;

            typedef AutoDocking_SendGoal_Request_DataReader * AutoDocking_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Request_DataReader> AutoDocking_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Request_DataReader> AutoDocking_SendGoal_Request_DataReader_out;


            class AutoDocking_SendGoal_Request_DataReaderView;

            typedef AutoDocking_SendGoal_Request_DataReaderView * AutoDocking_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Request_DataReaderView> AutoDocking_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Request_DataReaderView> AutoDocking_SendGoal_Request_DataReaderView_out;

            struct AutoDocking_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AutoDocking_SendGoal_Request_, struct AutoDocking_SendGoal_Request_Seq_uniq_> AutoDocking_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_SendGoal_Request_Seq> AutoDocking_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_SendGoal_Request_Seq> AutoDocking_SendGoal_Request_Seq_out;

            class  AutoDocking_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Request_TypeSupportInterface_var _var_type;

                static AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _duplicate (AutoDocking_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_SendGoal_Request_TypeSupportInterface () {};
                ~AutoDocking_SendGoal_Request_TypeSupportInterface () {};
            private:
                AutoDocking_SendGoal_Request_TypeSupportInterface (const AutoDocking_SendGoal_Request_TypeSupportInterface &);
                AutoDocking_SendGoal_Request_TypeSupportInterface & operator = (const AutoDocking_SendGoal_Request_TypeSupportInterface &);
            };

            class  AutoDocking_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Request_DataWriter_var _var_type;

                static AutoDocking_SendGoal_Request_DataWriter_ptr _duplicate (AutoDocking_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_SendGoal_Request_& instance_data) = 0;

            protected:
                AutoDocking_SendGoal_Request_DataWriter () {};
                ~AutoDocking_SendGoal_Request_DataWriter () {};
            private:
                AutoDocking_SendGoal_Request_DataWriter (const AutoDocking_SendGoal_Request_DataWriter &);
                AutoDocking_SendGoal_Request_DataWriter & operator = (const AutoDocking_SendGoal_Request_DataWriter &);
            };

            class  AutoDocking_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Request_DataReader_var _var_type;

                static AutoDocking_SendGoal_Request_DataReader_ptr _duplicate (AutoDocking_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_SendGoal_Request_& instance) = 0;

            protected:
                AutoDocking_SendGoal_Request_DataReader () {};
                ~AutoDocking_SendGoal_Request_DataReader () {};
            private:
                AutoDocking_SendGoal_Request_DataReader (const AutoDocking_SendGoal_Request_DataReader &);
                AutoDocking_SendGoal_Request_DataReader & operator = (const AutoDocking_SendGoal_Request_DataReader &);
            };

            class  AutoDocking_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Request_DataReaderView_var _var_type;

                static AutoDocking_SendGoal_Request_DataReaderView_ptr _duplicate (AutoDocking_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_SendGoal_Request_& instance) = 0;

            protected:
                AutoDocking_SendGoal_Request_DataReaderView () {};
                ~AutoDocking_SendGoal_Request_DataReaderView () {};
            private:
                AutoDocking_SendGoal_Request_DataReaderView (const AutoDocking_SendGoal_Request_DataReaderView &);
                AutoDocking_SendGoal_Request_DataReaderView & operator = (const AutoDocking_SendGoal_Request_DataReaderView &);
            };
            class AutoDocking_SendGoal_Response_TypeSupportInterface;

            typedef AutoDocking_SendGoal_Response_TypeSupportInterface * AutoDocking_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Response_TypeSupportInterface> AutoDocking_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Response_TypeSupportInterface> AutoDocking_SendGoal_Response_TypeSupportInterface_out;


            class AutoDocking_SendGoal_Response_DataWriter;

            typedef AutoDocking_SendGoal_Response_DataWriter * AutoDocking_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Response_DataWriter> AutoDocking_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Response_DataWriter> AutoDocking_SendGoal_Response_DataWriter_out;


            class AutoDocking_SendGoal_Response_DataReader;

            typedef AutoDocking_SendGoal_Response_DataReader * AutoDocking_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Response_DataReader> AutoDocking_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Response_DataReader> AutoDocking_SendGoal_Response_DataReader_out;


            class AutoDocking_SendGoal_Response_DataReaderView;

            typedef AutoDocking_SendGoal_Response_DataReaderView * AutoDocking_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_SendGoal_Response_DataReaderView> AutoDocking_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_SendGoal_Response_DataReaderView> AutoDocking_SendGoal_Response_DataReaderView_out;

            struct AutoDocking_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AutoDocking_SendGoal_Response_, struct AutoDocking_SendGoal_Response_Seq_uniq_> AutoDocking_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_SendGoal_Response_Seq> AutoDocking_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_SendGoal_Response_Seq> AutoDocking_SendGoal_Response_Seq_out;

            class  AutoDocking_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Response_TypeSupportInterface_var _var_type;

                static AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _duplicate (AutoDocking_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_SendGoal_Response_TypeSupportInterface () {};
                ~AutoDocking_SendGoal_Response_TypeSupportInterface () {};
            private:
                AutoDocking_SendGoal_Response_TypeSupportInterface (const AutoDocking_SendGoal_Response_TypeSupportInterface &);
                AutoDocking_SendGoal_Response_TypeSupportInterface & operator = (const AutoDocking_SendGoal_Response_TypeSupportInterface &);
            };

            class  AutoDocking_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Response_DataWriter_var _var_type;

                static AutoDocking_SendGoal_Response_DataWriter_ptr _duplicate (AutoDocking_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_SendGoal_Response_& instance_data) = 0;

            protected:
                AutoDocking_SendGoal_Response_DataWriter () {};
                ~AutoDocking_SendGoal_Response_DataWriter () {};
            private:
                AutoDocking_SendGoal_Response_DataWriter (const AutoDocking_SendGoal_Response_DataWriter &);
                AutoDocking_SendGoal_Response_DataWriter & operator = (const AutoDocking_SendGoal_Response_DataWriter &);
            };

            class  AutoDocking_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Response_DataReader_var _var_type;

                static AutoDocking_SendGoal_Response_DataReader_ptr _duplicate (AutoDocking_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_SendGoal_Response_& instance) = 0;

            protected:
                AutoDocking_SendGoal_Response_DataReader () {};
                ~AutoDocking_SendGoal_Response_DataReader () {};
            private:
                AutoDocking_SendGoal_Response_DataReader (const AutoDocking_SendGoal_Response_DataReader &);
                AutoDocking_SendGoal_Response_DataReader & operator = (const AutoDocking_SendGoal_Response_DataReader &);
            };

            class  AutoDocking_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_SendGoal_Response_DataReaderView_var _var_type;

                static AutoDocking_SendGoal_Response_DataReaderView_ptr _duplicate (AutoDocking_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_SendGoal_Response_& instance) = 0;

            protected:
                AutoDocking_SendGoal_Response_DataReaderView () {};
                ~AutoDocking_SendGoal_Response_DataReaderView () {};
            private:
                AutoDocking_SendGoal_Response_DataReaderView (const AutoDocking_SendGoal_Response_DataReaderView &);
                AutoDocking_SendGoal_Response_DataReaderView & operator = (const AutoDocking_SendGoal_Response_DataReaderView &);
            };
            class Sample_AutoDocking_SendGoal_Request_TypeSupportInterface;

            typedef Sample_AutoDocking_SendGoal_Request_TypeSupportInterface * Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Request_TypeSupportInterface> Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Request_TypeSupportInterface> Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_out;


            class Sample_AutoDocking_SendGoal_Request_DataWriter;

            typedef Sample_AutoDocking_SendGoal_Request_DataWriter * Sample_AutoDocking_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Request_DataWriter> Sample_AutoDocking_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Request_DataWriter> Sample_AutoDocking_SendGoal_Request_DataWriter_out;


            class Sample_AutoDocking_SendGoal_Request_DataReader;

            typedef Sample_AutoDocking_SendGoal_Request_DataReader * Sample_AutoDocking_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Request_DataReader> Sample_AutoDocking_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Request_DataReader> Sample_AutoDocking_SendGoal_Request_DataReader_out;


            class Sample_AutoDocking_SendGoal_Request_DataReaderView;

            typedef Sample_AutoDocking_SendGoal_Request_DataReaderView * Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Request_DataReaderView> Sample_AutoDocking_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Request_DataReaderView> Sample_AutoDocking_SendGoal_Request_DataReaderView_out;

            struct Sample_AutoDocking_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_AutoDocking_SendGoal_Request_, struct Sample_AutoDocking_SendGoal_Request_Seq_uniq_> Sample_AutoDocking_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AutoDocking_SendGoal_Request_Seq> Sample_AutoDocking_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AutoDocking_SendGoal_Request_Seq> Sample_AutoDocking_SendGoal_Request_Seq_out;

            class  Sample_AutoDocking_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AutoDocking_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_AutoDocking_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_AutoDocking_SendGoal_Request_TypeSupportInterface (const Sample_AutoDocking_SendGoal_Request_TypeSupportInterface &);
                Sample_AutoDocking_SendGoal_Request_TypeSupportInterface & operator = (const Sample_AutoDocking_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_AutoDocking_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Request_DataWriter_var _var_type;

                static Sample_AutoDocking_SendGoal_Request_DataWriter_ptr _duplicate (Sample_AutoDocking_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AutoDocking_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AutoDocking_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AutoDocking_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_AutoDocking_SendGoal_Request_DataWriter () {};
                ~Sample_AutoDocking_SendGoal_Request_DataWriter () {};
            private:
                Sample_AutoDocking_SendGoal_Request_DataWriter (const Sample_AutoDocking_SendGoal_Request_DataWriter &);
                Sample_AutoDocking_SendGoal_Request_DataWriter & operator = (const Sample_AutoDocking_SendGoal_Request_DataWriter &);
            };

            class  Sample_AutoDocking_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Request_DataReader_var _var_type;

                static Sample_AutoDocking_SendGoal_Request_DataReader_ptr _duplicate (Sample_AutoDocking_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_SendGoal_Request_& instance) = 0;

            protected:
                Sample_AutoDocking_SendGoal_Request_DataReader () {};
                ~Sample_AutoDocking_SendGoal_Request_DataReader () {};
            private:
                Sample_AutoDocking_SendGoal_Request_DataReader (const Sample_AutoDocking_SendGoal_Request_DataReader &);
                Sample_AutoDocking_SendGoal_Request_DataReader & operator = (const Sample_AutoDocking_SendGoal_Request_DataReader &);
            };

            class  Sample_AutoDocking_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_SendGoal_Request_& instance) = 0;

            protected:
                Sample_AutoDocking_SendGoal_Request_DataReaderView () {};
                ~Sample_AutoDocking_SendGoal_Request_DataReaderView () {};
            private:
                Sample_AutoDocking_SendGoal_Request_DataReaderView (const Sample_AutoDocking_SendGoal_Request_DataReaderView &);
                Sample_AutoDocking_SendGoal_Request_DataReaderView & operator = (const Sample_AutoDocking_SendGoal_Request_DataReaderView &);
            };
            class Sample_AutoDocking_SendGoal_Response_TypeSupportInterface;

            typedef Sample_AutoDocking_SendGoal_Response_TypeSupportInterface * Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Response_TypeSupportInterface> Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Response_TypeSupportInterface> Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_out;


            class Sample_AutoDocking_SendGoal_Response_DataWriter;

            typedef Sample_AutoDocking_SendGoal_Response_DataWriter * Sample_AutoDocking_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Response_DataWriter> Sample_AutoDocking_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Response_DataWriter> Sample_AutoDocking_SendGoal_Response_DataWriter_out;


            class Sample_AutoDocking_SendGoal_Response_DataReader;

            typedef Sample_AutoDocking_SendGoal_Response_DataReader * Sample_AutoDocking_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Response_DataReader> Sample_AutoDocking_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Response_DataReader> Sample_AutoDocking_SendGoal_Response_DataReader_out;


            class Sample_AutoDocking_SendGoal_Response_DataReaderView;

            typedef Sample_AutoDocking_SendGoal_Response_DataReaderView * Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_SendGoal_Response_DataReaderView> Sample_AutoDocking_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_SendGoal_Response_DataReaderView> Sample_AutoDocking_SendGoal_Response_DataReaderView_out;

            struct Sample_AutoDocking_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_AutoDocking_SendGoal_Response_, struct Sample_AutoDocking_SendGoal_Response_Seq_uniq_> Sample_AutoDocking_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AutoDocking_SendGoal_Response_Seq> Sample_AutoDocking_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AutoDocking_SendGoal_Response_Seq> Sample_AutoDocking_SendGoal_Response_Seq_out;

            class  Sample_AutoDocking_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AutoDocking_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_AutoDocking_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_AutoDocking_SendGoal_Response_TypeSupportInterface (const Sample_AutoDocking_SendGoal_Response_TypeSupportInterface &);
                Sample_AutoDocking_SendGoal_Response_TypeSupportInterface & operator = (const Sample_AutoDocking_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_AutoDocking_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Response_DataWriter_var _var_type;

                static Sample_AutoDocking_SendGoal_Response_DataWriter_ptr _duplicate (Sample_AutoDocking_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AutoDocking_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AutoDocking_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AutoDocking_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_AutoDocking_SendGoal_Response_DataWriter () {};
                ~Sample_AutoDocking_SendGoal_Response_DataWriter () {};
            private:
                Sample_AutoDocking_SendGoal_Response_DataWriter (const Sample_AutoDocking_SendGoal_Response_DataWriter &);
                Sample_AutoDocking_SendGoal_Response_DataWriter & operator = (const Sample_AutoDocking_SendGoal_Response_DataWriter &);
            };

            class  Sample_AutoDocking_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Response_DataReader_var _var_type;

                static Sample_AutoDocking_SendGoal_Response_DataReader_ptr _duplicate (Sample_AutoDocking_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_SendGoal_Response_& instance) = 0;

            protected:
                Sample_AutoDocking_SendGoal_Response_DataReader () {};
                ~Sample_AutoDocking_SendGoal_Response_DataReader () {};
            private:
                Sample_AutoDocking_SendGoal_Response_DataReader (const Sample_AutoDocking_SendGoal_Response_DataReader &);
                Sample_AutoDocking_SendGoal_Response_DataReader & operator = (const Sample_AutoDocking_SendGoal_Response_DataReader &);
            };

            class  Sample_AutoDocking_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AutoDocking_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_SendGoal_Response_& instance) = 0;

            protected:
                Sample_AutoDocking_SendGoal_Response_DataReaderView () {};
                ~Sample_AutoDocking_SendGoal_Response_DataReaderView () {};
            private:
                Sample_AutoDocking_SendGoal_Response_DataReaderView (const Sample_AutoDocking_SendGoal_Response_DataReaderView &);
                Sample_AutoDocking_SendGoal_Response_DataReaderView & operator = (const Sample_AutoDocking_SendGoal_Response_DataReaderView &);
            };
            class AutoDocking_Result_TypeSupportInterface;

            typedef AutoDocking_Result_TypeSupportInterface * AutoDocking_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Result_TypeSupportInterface> AutoDocking_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Result_TypeSupportInterface> AutoDocking_Result_TypeSupportInterface_out;


            class AutoDocking_Result_DataWriter;

            typedef AutoDocking_Result_DataWriter * AutoDocking_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Result_DataWriter> AutoDocking_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Result_DataWriter> AutoDocking_Result_DataWriter_out;


            class AutoDocking_Result_DataReader;

            typedef AutoDocking_Result_DataReader * AutoDocking_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Result_DataReader> AutoDocking_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Result_DataReader> AutoDocking_Result_DataReader_out;


            class AutoDocking_Result_DataReaderView;

            typedef AutoDocking_Result_DataReaderView * AutoDocking_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Result_DataReaderView> AutoDocking_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Result_DataReaderView> AutoDocking_Result_DataReaderView_out;

            struct AutoDocking_Result_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AutoDocking_Result_, struct AutoDocking_Result_Seq_uniq_> AutoDocking_Result_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_Result_Seq> AutoDocking_Result_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_Result_Seq> AutoDocking_Result_Seq_out;

            class  AutoDocking_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_Result_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_Result_TypeSupportInterface_var _var_type;

                static AutoDocking_Result_TypeSupportInterface_ptr _duplicate (AutoDocking_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_Result_TypeSupportInterface () {};
                ~AutoDocking_Result_TypeSupportInterface () {};
            private:
                AutoDocking_Result_TypeSupportInterface (const AutoDocking_Result_TypeSupportInterface &);
                AutoDocking_Result_TypeSupportInterface & operator = (const AutoDocking_Result_TypeSupportInterface &);
            };

            class  AutoDocking_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_Result_DataWriter_ptr _ptr_type;
                typedef AutoDocking_Result_DataWriter_var _var_type;

                static AutoDocking_Result_DataWriter_ptr _duplicate (AutoDocking_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Result_& instance_data) = 0;

            protected:
                AutoDocking_Result_DataWriter () {};
                ~AutoDocking_Result_DataWriter () {};
            private:
                AutoDocking_Result_DataWriter (const AutoDocking_Result_DataWriter &);
                AutoDocking_Result_DataWriter & operator = (const AutoDocking_Result_DataWriter &);
            };

            class  AutoDocking_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_Result_DataReader_ptr _ptr_type;
                typedef AutoDocking_Result_DataReader_var _var_type;

                static AutoDocking_Result_DataReader_ptr _duplicate (AutoDocking_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Result_& instance) = 0;

            protected:
                AutoDocking_Result_DataReader () {};
                ~AutoDocking_Result_DataReader () {};
            private:
                AutoDocking_Result_DataReader (const AutoDocking_Result_DataReader &);
                AutoDocking_Result_DataReader & operator = (const AutoDocking_Result_DataReader &);
            };

            class  AutoDocking_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_Result_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_Result_DataReaderView_var _var_type;

                static AutoDocking_Result_DataReaderView_ptr _duplicate (AutoDocking_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Result_& instance) = 0;

            protected:
                AutoDocking_Result_DataReaderView () {};
                ~AutoDocking_Result_DataReaderView () {};
            private:
                AutoDocking_Result_DataReaderView (const AutoDocking_Result_DataReaderView &);
                AutoDocking_Result_DataReaderView & operator = (const AutoDocking_Result_DataReaderView &);
            };
            class AutoDocking_GetResult_Request_TypeSupportInterface;

            typedef AutoDocking_GetResult_Request_TypeSupportInterface * AutoDocking_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Request_TypeSupportInterface> AutoDocking_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Request_TypeSupportInterface> AutoDocking_GetResult_Request_TypeSupportInterface_out;


            class AutoDocking_GetResult_Request_DataWriter;

            typedef AutoDocking_GetResult_Request_DataWriter * AutoDocking_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Request_DataWriter> AutoDocking_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Request_DataWriter> AutoDocking_GetResult_Request_DataWriter_out;


            class AutoDocking_GetResult_Request_DataReader;

            typedef AutoDocking_GetResult_Request_DataReader * AutoDocking_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Request_DataReader> AutoDocking_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Request_DataReader> AutoDocking_GetResult_Request_DataReader_out;


            class AutoDocking_GetResult_Request_DataReaderView;

            typedef AutoDocking_GetResult_Request_DataReaderView * AutoDocking_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Request_DataReaderView> AutoDocking_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Request_DataReaderView> AutoDocking_GetResult_Request_DataReaderView_out;

            struct AutoDocking_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AutoDocking_GetResult_Request_, struct AutoDocking_GetResult_Request_Seq_uniq_> AutoDocking_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_GetResult_Request_Seq> AutoDocking_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_GetResult_Request_Seq> AutoDocking_GetResult_Request_Seq_out;

            class  AutoDocking_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_GetResult_Request_TypeSupportInterface_var _var_type;

                static AutoDocking_GetResult_Request_TypeSupportInterface_ptr _duplicate (AutoDocking_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_GetResult_Request_TypeSupportInterface () {};
                ~AutoDocking_GetResult_Request_TypeSupportInterface () {};
            private:
                AutoDocking_GetResult_Request_TypeSupportInterface (const AutoDocking_GetResult_Request_TypeSupportInterface &);
                AutoDocking_GetResult_Request_TypeSupportInterface & operator = (const AutoDocking_GetResult_Request_TypeSupportInterface &);
            };

            class  AutoDocking_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef AutoDocking_GetResult_Request_DataWriter_var _var_type;

                static AutoDocking_GetResult_Request_DataWriter_ptr _duplicate (AutoDocking_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_GetResult_Request_& instance_data) = 0;

            protected:
                AutoDocking_GetResult_Request_DataWriter () {};
                ~AutoDocking_GetResult_Request_DataWriter () {};
            private:
                AutoDocking_GetResult_Request_DataWriter (const AutoDocking_GetResult_Request_DataWriter &);
                AutoDocking_GetResult_Request_DataWriter & operator = (const AutoDocking_GetResult_Request_DataWriter &);
            };

            class  AutoDocking_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_GetResult_Request_DataReader_ptr _ptr_type;
                typedef AutoDocking_GetResult_Request_DataReader_var _var_type;

                static AutoDocking_GetResult_Request_DataReader_ptr _duplicate (AutoDocking_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_GetResult_Request_& instance) = 0;

            protected:
                AutoDocking_GetResult_Request_DataReader () {};
                ~AutoDocking_GetResult_Request_DataReader () {};
            private:
                AutoDocking_GetResult_Request_DataReader (const AutoDocking_GetResult_Request_DataReader &);
                AutoDocking_GetResult_Request_DataReader & operator = (const AutoDocking_GetResult_Request_DataReader &);
            };

            class  AutoDocking_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_GetResult_Request_DataReaderView_var _var_type;

                static AutoDocking_GetResult_Request_DataReaderView_ptr _duplicate (AutoDocking_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_GetResult_Request_& instance) = 0;

            protected:
                AutoDocking_GetResult_Request_DataReaderView () {};
                ~AutoDocking_GetResult_Request_DataReaderView () {};
            private:
                AutoDocking_GetResult_Request_DataReaderView (const AutoDocking_GetResult_Request_DataReaderView &);
                AutoDocking_GetResult_Request_DataReaderView & operator = (const AutoDocking_GetResult_Request_DataReaderView &);
            };
            class AutoDocking_GetResult_Response_TypeSupportInterface;

            typedef AutoDocking_GetResult_Response_TypeSupportInterface * AutoDocking_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Response_TypeSupportInterface> AutoDocking_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Response_TypeSupportInterface> AutoDocking_GetResult_Response_TypeSupportInterface_out;


            class AutoDocking_GetResult_Response_DataWriter;

            typedef AutoDocking_GetResult_Response_DataWriter * AutoDocking_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Response_DataWriter> AutoDocking_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Response_DataWriter> AutoDocking_GetResult_Response_DataWriter_out;


            class AutoDocking_GetResult_Response_DataReader;

            typedef AutoDocking_GetResult_Response_DataReader * AutoDocking_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Response_DataReader> AutoDocking_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Response_DataReader> AutoDocking_GetResult_Response_DataReader_out;


            class AutoDocking_GetResult_Response_DataReaderView;

            typedef AutoDocking_GetResult_Response_DataReaderView * AutoDocking_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_GetResult_Response_DataReaderView> AutoDocking_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_GetResult_Response_DataReaderView> AutoDocking_GetResult_Response_DataReaderView_out;

            struct AutoDocking_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AutoDocking_GetResult_Response_, struct AutoDocking_GetResult_Response_Seq_uniq_> AutoDocking_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_GetResult_Response_Seq> AutoDocking_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_GetResult_Response_Seq> AutoDocking_GetResult_Response_Seq_out;

            class  AutoDocking_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_GetResult_Response_TypeSupportInterface_var _var_type;

                static AutoDocking_GetResult_Response_TypeSupportInterface_ptr _duplicate (AutoDocking_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_GetResult_Response_TypeSupportInterface () {};
                ~AutoDocking_GetResult_Response_TypeSupportInterface () {};
            private:
                AutoDocking_GetResult_Response_TypeSupportInterface (const AutoDocking_GetResult_Response_TypeSupportInterface &);
                AutoDocking_GetResult_Response_TypeSupportInterface & operator = (const AutoDocking_GetResult_Response_TypeSupportInterface &);
            };

            class  AutoDocking_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef AutoDocking_GetResult_Response_DataWriter_var _var_type;

                static AutoDocking_GetResult_Response_DataWriter_ptr _duplicate (AutoDocking_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_GetResult_Response_& instance_data) = 0;

            protected:
                AutoDocking_GetResult_Response_DataWriter () {};
                ~AutoDocking_GetResult_Response_DataWriter () {};
            private:
                AutoDocking_GetResult_Response_DataWriter (const AutoDocking_GetResult_Response_DataWriter &);
                AutoDocking_GetResult_Response_DataWriter & operator = (const AutoDocking_GetResult_Response_DataWriter &);
            };

            class  AutoDocking_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_GetResult_Response_DataReader_ptr _ptr_type;
                typedef AutoDocking_GetResult_Response_DataReader_var _var_type;

                static AutoDocking_GetResult_Response_DataReader_ptr _duplicate (AutoDocking_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_GetResult_Response_& instance) = 0;

            protected:
                AutoDocking_GetResult_Response_DataReader () {};
                ~AutoDocking_GetResult_Response_DataReader () {};
            private:
                AutoDocking_GetResult_Response_DataReader (const AutoDocking_GetResult_Response_DataReader &);
                AutoDocking_GetResult_Response_DataReader & operator = (const AutoDocking_GetResult_Response_DataReader &);
            };

            class  AutoDocking_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_GetResult_Response_DataReaderView_var _var_type;

                static AutoDocking_GetResult_Response_DataReaderView_ptr _duplicate (AutoDocking_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_GetResult_Response_& instance) = 0;

            protected:
                AutoDocking_GetResult_Response_DataReaderView () {};
                ~AutoDocking_GetResult_Response_DataReaderView () {};
            private:
                AutoDocking_GetResult_Response_DataReaderView (const AutoDocking_GetResult_Response_DataReaderView &);
                AutoDocking_GetResult_Response_DataReaderView & operator = (const AutoDocking_GetResult_Response_DataReaderView &);
            };
            class Sample_AutoDocking_GetResult_Request_TypeSupportInterface;

            typedef Sample_AutoDocking_GetResult_Request_TypeSupportInterface * Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Request_TypeSupportInterface> Sample_AutoDocking_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Request_TypeSupportInterface> Sample_AutoDocking_GetResult_Request_TypeSupportInterface_out;


            class Sample_AutoDocking_GetResult_Request_DataWriter;

            typedef Sample_AutoDocking_GetResult_Request_DataWriter * Sample_AutoDocking_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Request_DataWriter> Sample_AutoDocking_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Request_DataWriter> Sample_AutoDocking_GetResult_Request_DataWriter_out;


            class Sample_AutoDocking_GetResult_Request_DataReader;

            typedef Sample_AutoDocking_GetResult_Request_DataReader * Sample_AutoDocking_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Request_DataReader> Sample_AutoDocking_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Request_DataReader> Sample_AutoDocking_GetResult_Request_DataReader_out;


            class Sample_AutoDocking_GetResult_Request_DataReaderView;

            typedef Sample_AutoDocking_GetResult_Request_DataReaderView * Sample_AutoDocking_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Request_DataReaderView> Sample_AutoDocking_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Request_DataReaderView> Sample_AutoDocking_GetResult_Request_DataReaderView_out;

            struct Sample_AutoDocking_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_AutoDocking_GetResult_Request_, struct Sample_AutoDocking_GetResult_Request_Seq_uniq_> Sample_AutoDocking_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AutoDocking_GetResult_Request_Seq> Sample_AutoDocking_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AutoDocking_GetResult_Request_Seq> Sample_AutoDocking_GetResult_Request_Seq_out;

            class  Sample_AutoDocking_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AutoDocking_GetResult_Request_TypeSupportInterface () {};
                ~Sample_AutoDocking_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_AutoDocking_GetResult_Request_TypeSupportInterface (const Sample_AutoDocking_GetResult_Request_TypeSupportInterface &);
                Sample_AutoDocking_GetResult_Request_TypeSupportInterface & operator = (const Sample_AutoDocking_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_AutoDocking_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Request_DataWriter_var _var_type;

                static Sample_AutoDocking_GetResult_Request_DataWriter_ptr _duplicate (Sample_AutoDocking_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AutoDocking_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AutoDocking_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AutoDocking_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_AutoDocking_GetResult_Request_DataWriter () {};
                ~Sample_AutoDocking_GetResult_Request_DataWriter () {};
            private:
                Sample_AutoDocking_GetResult_Request_DataWriter (const Sample_AutoDocking_GetResult_Request_DataWriter &);
                Sample_AutoDocking_GetResult_Request_DataWriter & operator = (const Sample_AutoDocking_GetResult_Request_DataWriter &);
            };

            class  Sample_AutoDocking_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Request_DataReader_var _var_type;

                static Sample_AutoDocking_GetResult_Request_DataReader_ptr _duplicate (Sample_AutoDocking_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_GetResult_Request_& instance) = 0;

            protected:
                Sample_AutoDocking_GetResult_Request_DataReader () {};
                ~Sample_AutoDocking_GetResult_Request_DataReader () {};
            private:
                Sample_AutoDocking_GetResult_Request_DataReader (const Sample_AutoDocking_GetResult_Request_DataReader &);
                Sample_AutoDocking_GetResult_Request_DataReader & operator = (const Sample_AutoDocking_GetResult_Request_DataReader &);
            };

            class  Sample_AutoDocking_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Request_DataReaderView_var _var_type;

                static Sample_AutoDocking_GetResult_Request_DataReaderView_ptr _duplicate (Sample_AutoDocking_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_GetResult_Request_& instance) = 0;

            protected:
                Sample_AutoDocking_GetResult_Request_DataReaderView () {};
                ~Sample_AutoDocking_GetResult_Request_DataReaderView () {};
            private:
                Sample_AutoDocking_GetResult_Request_DataReaderView (const Sample_AutoDocking_GetResult_Request_DataReaderView &);
                Sample_AutoDocking_GetResult_Request_DataReaderView & operator = (const Sample_AutoDocking_GetResult_Request_DataReaderView &);
            };
            class Sample_AutoDocking_GetResult_Response_TypeSupportInterface;

            typedef Sample_AutoDocking_GetResult_Response_TypeSupportInterface * Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Response_TypeSupportInterface> Sample_AutoDocking_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Response_TypeSupportInterface> Sample_AutoDocking_GetResult_Response_TypeSupportInterface_out;


            class Sample_AutoDocking_GetResult_Response_DataWriter;

            typedef Sample_AutoDocking_GetResult_Response_DataWriter * Sample_AutoDocking_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Response_DataWriter> Sample_AutoDocking_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Response_DataWriter> Sample_AutoDocking_GetResult_Response_DataWriter_out;


            class Sample_AutoDocking_GetResult_Response_DataReader;

            typedef Sample_AutoDocking_GetResult_Response_DataReader * Sample_AutoDocking_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Response_DataReader> Sample_AutoDocking_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Response_DataReader> Sample_AutoDocking_GetResult_Response_DataReader_out;


            class Sample_AutoDocking_GetResult_Response_DataReaderView;

            typedef Sample_AutoDocking_GetResult_Response_DataReaderView * Sample_AutoDocking_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutoDocking_GetResult_Response_DataReaderView> Sample_AutoDocking_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AutoDocking_GetResult_Response_DataReaderView> Sample_AutoDocking_GetResult_Response_DataReaderView_out;

            struct Sample_AutoDocking_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AutoDocking_GetResult_Response_, struct Sample_AutoDocking_GetResult_Response_Seq_uniq_> Sample_AutoDocking_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AutoDocking_GetResult_Response_Seq> Sample_AutoDocking_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AutoDocking_GetResult_Response_Seq> Sample_AutoDocking_GetResult_Response_Seq_out;

            class  Sample_AutoDocking_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AutoDocking_GetResult_Response_TypeSupportInterface () {};
                ~Sample_AutoDocking_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_AutoDocking_GetResult_Response_TypeSupportInterface (const Sample_AutoDocking_GetResult_Response_TypeSupportInterface &);
                Sample_AutoDocking_GetResult_Response_TypeSupportInterface & operator = (const Sample_AutoDocking_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_AutoDocking_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Response_DataWriter_var _var_type;

                static Sample_AutoDocking_GetResult_Response_DataWriter_ptr _duplicate (Sample_AutoDocking_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AutoDocking_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AutoDocking_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AutoDocking_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_AutoDocking_GetResult_Response_DataWriter () {};
                ~Sample_AutoDocking_GetResult_Response_DataWriter () {};
            private:
                Sample_AutoDocking_GetResult_Response_DataWriter (const Sample_AutoDocking_GetResult_Response_DataWriter &);
                Sample_AutoDocking_GetResult_Response_DataWriter & operator = (const Sample_AutoDocking_GetResult_Response_DataWriter &);
            };

            class  Sample_AutoDocking_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Response_DataReader_var _var_type;

                static Sample_AutoDocking_GetResult_Response_DataReader_ptr _duplicate (Sample_AutoDocking_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_GetResult_Response_& instance) = 0;

            protected:
                Sample_AutoDocking_GetResult_Response_DataReader () {};
                ~Sample_AutoDocking_GetResult_Response_DataReader () {};
            private:
                Sample_AutoDocking_GetResult_Response_DataReader (const Sample_AutoDocking_GetResult_Response_DataReader &);
                Sample_AutoDocking_GetResult_Response_DataReader & operator = (const Sample_AutoDocking_GetResult_Response_DataReader &);
            };

            class  Sample_AutoDocking_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AutoDocking_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AutoDocking_GetResult_Response_DataReaderView_var _var_type;

                static Sample_AutoDocking_GetResult_Response_DataReaderView_ptr _duplicate (Sample_AutoDocking_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutoDocking_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutoDocking_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutoDocking_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutoDocking_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutoDocking_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutoDocking_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutoDocking_GetResult_Response_& instance) = 0;

            protected:
                Sample_AutoDocking_GetResult_Response_DataReaderView () {};
                ~Sample_AutoDocking_GetResult_Response_DataReaderView () {};
            private:
                Sample_AutoDocking_GetResult_Response_DataReaderView (const Sample_AutoDocking_GetResult_Response_DataReaderView &);
                Sample_AutoDocking_GetResult_Response_DataReaderView & operator = (const Sample_AutoDocking_GetResult_Response_DataReaderView &);
            };
            class AutoDocking_Feedback_TypeSupportInterface;

            typedef AutoDocking_Feedback_TypeSupportInterface * AutoDocking_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Feedback_TypeSupportInterface> AutoDocking_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Feedback_TypeSupportInterface> AutoDocking_Feedback_TypeSupportInterface_out;


            class AutoDocking_Feedback_DataWriter;

            typedef AutoDocking_Feedback_DataWriter * AutoDocking_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Feedback_DataWriter> AutoDocking_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Feedback_DataWriter> AutoDocking_Feedback_DataWriter_out;


            class AutoDocking_Feedback_DataReader;

            typedef AutoDocking_Feedback_DataReader * AutoDocking_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Feedback_DataReader> AutoDocking_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Feedback_DataReader> AutoDocking_Feedback_DataReader_out;


            class AutoDocking_Feedback_DataReaderView;

            typedef AutoDocking_Feedback_DataReaderView * AutoDocking_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_Feedback_DataReaderView> AutoDocking_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_Feedback_DataReaderView> AutoDocking_Feedback_DataReaderView_out;

            struct AutoDocking_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AutoDocking_Feedback_, struct AutoDocking_Feedback_Seq_uniq_> AutoDocking_Feedback_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_Feedback_Seq> AutoDocking_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_Feedback_Seq> AutoDocking_Feedback_Seq_out;

            class  AutoDocking_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_Feedback_TypeSupportInterface_var _var_type;

                static AutoDocking_Feedback_TypeSupportInterface_ptr _duplicate (AutoDocking_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_Feedback_TypeSupportInterface () {};
                ~AutoDocking_Feedback_TypeSupportInterface () {};
            private:
                AutoDocking_Feedback_TypeSupportInterface (const AutoDocking_Feedback_TypeSupportInterface &);
                AutoDocking_Feedback_TypeSupportInterface & operator = (const AutoDocking_Feedback_TypeSupportInterface &);
            };

            class  AutoDocking_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_Feedback_DataWriter_ptr _ptr_type;
                typedef AutoDocking_Feedback_DataWriter_var _var_type;

                static AutoDocking_Feedback_DataWriter_ptr _duplicate (AutoDocking_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Feedback_& instance_data) = 0;

            protected:
                AutoDocking_Feedback_DataWriter () {};
                ~AutoDocking_Feedback_DataWriter () {};
            private:
                AutoDocking_Feedback_DataWriter (const AutoDocking_Feedback_DataWriter &);
                AutoDocking_Feedback_DataWriter & operator = (const AutoDocking_Feedback_DataWriter &);
            };

            class  AutoDocking_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_Feedback_DataReader_ptr _ptr_type;
                typedef AutoDocking_Feedback_DataReader_var _var_type;

                static AutoDocking_Feedback_DataReader_ptr _duplicate (AutoDocking_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Feedback_& instance) = 0;

            protected:
                AutoDocking_Feedback_DataReader () {};
                ~AutoDocking_Feedback_DataReader () {};
            private:
                AutoDocking_Feedback_DataReader (const AutoDocking_Feedback_DataReader &);
                AutoDocking_Feedback_DataReader & operator = (const AutoDocking_Feedback_DataReader &);
            };

            class  AutoDocking_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_Feedback_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_Feedback_DataReaderView_var _var_type;

                static AutoDocking_Feedback_DataReaderView_ptr _duplicate (AutoDocking_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_Feedback_& instance) = 0;

            protected:
                AutoDocking_Feedback_DataReaderView () {};
                ~AutoDocking_Feedback_DataReaderView () {};
            private:
                AutoDocking_Feedback_DataReaderView (const AutoDocking_Feedback_DataReaderView &);
                AutoDocking_Feedback_DataReaderView & operator = (const AutoDocking_Feedback_DataReaderView &);
            };
            class AutoDocking_FeedbackMessage_TypeSupportInterface;

            typedef AutoDocking_FeedbackMessage_TypeSupportInterface * AutoDocking_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_FeedbackMessage_TypeSupportInterface> AutoDocking_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutoDocking_FeedbackMessage_TypeSupportInterface> AutoDocking_FeedbackMessage_TypeSupportInterface_out;


            class AutoDocking_FeedbackMessage_DataWriter;

            typedef AutoDocking_FeedbackMessage_DataWriter * AutoDocking_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_FeedbackMessage_DataWriter> AutoDocking_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutoDocking_FeedbackMessage_DataWriter> AutoDocking_FeedbackMessage_DataWriter_out;


            class AutoDocking_FeedbackMessage_DataReader;

            typedef AutoDocking_FeedbackMessage_DataReader * AutoDocking_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_FeedbackMessage_DataReader> AutoDocking_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < AutoDocking_FeedbackMessage_DataReader> AutoDocking_FeedbackMessage_DataReader_out;


            class AutoDocking_FeedbackMessage_DataReaderView;

            typedef AutoDocking_FeedbackMessage_DataReaderView * AutoDocking_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutoDocking_FeedbackMessage_DataReaderView> AutoDocking_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutoDocking_FeedbackMessage_DataReaderView> AutoDocking_FeedbackMessage_DataReaderView_out;

            struct AutoDocking_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AutoDocking_FeedbackMessage_, struct AutoDocking_FeedbackMessage_Seq_uniq_> AutoDocking_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < AutoDocking_FeedbackMessage_Seq> AutoDocking_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < AutoDocking_FeedbackMessage_Seq> AutoDocking_FeedbackMessage_Seq_out;

            class  AutoDocking_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutoDocking_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef AutoDocking_FeedbackMessage_TypeSupportInterface_var _var_type;

                static AutoDocking_FeedbackMessage_TypeSupportInterface_ptr _duplicate (AutoDocking_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutoDocking_FeedbackMessage_TypeSupportInterface () {};
                ~AutoDocking_FeedbackMessage_TypeSupportInterface () {};
            private:
                AutoDocking_FeedbackMessage_TypeSupportInterface (const AutoDocking_FeedbackMessage_TypeSupportInterface &);
                AutoDocking_FeedbackMessage_TypeSupportInterface & operator = (const AutoDocking_FeedbackMessage_TypeSupportInterface &);
            };

            class  AutoDocking_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutoDocking_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef AutoDocking_FeedbackMessage_DataWriter_var _var_type;

                static AutoDocking_FeedbackMessage_DataWriter_ptr _duplicate (AutoDocking_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutoDocking_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutoDocking_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutoDocking_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutoDocking_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_FeedbackMessage_& instance_data) = 0;

            protected:
                AutoDocking_FeedbackMessage_DataWriter () {};
                ~AutoDocking_FeedbackMessage_DataWriter () {};
            private:
                AutoDocking_FeedbackMessage_DataWriter (const AutoDocking_FeedbackMessage_DataWriter &);
                AutoDocking_FeedbackMessage_DataWriter & operator = (const AutoDocking_FeedbackMessage_DataWriter &);
            };

            class  AutoDocking_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutoDocking_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef AutoDocking_FeedbackMessage_DataReader_var _var_type;

                static AutoDocking_FeedbackMessage_DataReader_ptr _duplicate (AutoDocking_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_FeedbackMessage_& instance) = 0;

            protected:
                AutoDocking_FeedbackMessage_DataReader () {};
                ~AutoDocking_FeedbackMessage_DataReader () {};
            private:
                AutoDocking_FeedbackMessage_DataReader (const AutoDocking_FeedbackMessage_DataReader &);
                AutoDocking_FeedbackMessage_DataReader & operator = (const AutoDocking_FeedbackMessage_DataReader &);
            };

            class  AutoDocking_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutoDocking_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef AutoDocking_FeedbackMessage_DataReaderView_var _var_type;

                static AutoDocking_FeedbackMessage_DataReaderView_ptr _duplicate (AutoDocking_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutoDocking_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutoDocking_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutoDocking_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutoDocking_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutoDocking_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutoDocking_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutoDocking_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutoDocking_FeedbackMessage_& instance) = 0;

            protected:
                AutoDocking_FeedbackMessage_DataReaderView () {};
                ~AutoDocking_FeedbackMessage_DataReaderView () {};
            private:
                AutoDocking_FeedbackMessage_DataReaderView (const AutoDocking_FeedbackMessage_DataReaderView &);
                AutoDocking_FeedbackMessage_DataReaderView & operator = (const AutoDocking_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
