#ifndef _H_F80E023CAA7395B9134AFCC9BC1405D8_CliffEvent_DCPS_H_
#define _H_F80E023CAA7395B9134AFCC9BC1405D8_CliffEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CliffEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class CliffEvent_TypeSupportInterface;

            typedef CliffEvent_TypeSupportInterface * CliffEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CliffEvent_TypeSupportInterface> CliffEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CliffEvent_TypeSupportInterface> CliffEvent_TypeSupportInterface_out;


            class CliffEvent_DataWriter;

            typedef CliffEvent_DataWriter * CliffEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CliffEvent_DataWriter> CliffEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < CliffEvent_DataWriter> CliffEvent_DataWriter_out;


            class CliffEvent_DataReader;

            typedef CliffEvent_DataReader * CliffEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CliffEvent_DataReader> CliffEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < CliffEvent_DataReader> CliffEvent_DataReader_out;


            class CliffEvent_DataReaderView;

            typedef CliffEvent_DataReaderView * CliffEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CliffEvent_DataReaderView> CliffEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CliffEvent_DataReaderView> CliffEvent_DataReaderView_out;

            struct CliffEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CliffEvent_, struct CliffEvent_Seq_uniq_> CliffEvent_Seq;
            typedef DDS_DCPSSequence_var < CliffEvent_Seq> CliffEvent_Seq_var;
            typedef DDS_DCPSSequence_out < CliffEvent_Seq> CliffEvent_Seq_out;

            class  CliffEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CliffEvent_TypeSupportInterface_ptr _ptr_type;
                typedef CliffEvent_TypeSupportInterface_var _var_type;

                static CliffEvent_TypeSupportInterface_ptr _duplicate (CliffEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CliffEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CliffEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CliffEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CliffEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CliffEvent_TypeSupportInterface () {};
                ~CliffEvent_TypeSupportInterface () {};
            private:
                CliffEvent_TypeSupportInterface (const CliffEvent_TypeSupportInterface &);
                CliffEvent_TypeSupportInterface & operator = (const CliffEvent_TypeSupportInterface &);
            };

            class  CliffEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CliffEvent_DataWriter_ptr _ptr_type;
                typedef CliffEvent_DataWriter_var _var_type;

                static CliffEvent_DataWriter_ptr _duplicate (CliffEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CliffEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CliffEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CliffEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CliffEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CliffEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CliffEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CliffEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CliffEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CliffEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CliffEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CliffEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CliffEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CliffEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CliffEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CliffEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CliffEvent_& instance_data) = 0;

            protected:
                CliffEvent_DataWriter () {};
                ~CliffEvent_DataWriter () {};
            private:
                CliffEvent_DataWriter (const CliffEvent_DataWriter &);
                CliffEvent_DataWriter & operator = (const CliffEvent_DataWriter &);
            };

            class  CliffEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CliffEvent_DataReader_ptr _ptr_type;
                typedef CliffEvent_DataReader_var _var_type;

                static CliffEvent_DataReader_ptr _duplicate (CliffEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CliffEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CliffEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CliffEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CliffEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CliffEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CliffEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CliffEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CliffEvent_& instance) = 0;

            protected:
                CliffEvent_DataReader () {};
                ~CliffEvent_DataReader () {};
            private:
                CliffEvent_DataReader (const CliffEvent_DataReader &);
                CliffEvent_DataReader & operator = (const CliffEvent_DataReader &);
            };

            class  CliffEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CliffEvent_DataReaderView_ptr _ptr_type;
                typedef CliffEvent_DataReaderView_var _var_type;

                static CliffEvent_DataReaderView_ptr _duplicate (CliffEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CliffEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CliffEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CliffEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CliffEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CliffEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CliffEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CliffEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CliffEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CliffEvent_& instance) = 0;

            protected:
                CliffEvent_DataReaderView () {};
                ~CliffEvent_DataReaderView () {};
            private:
                CliffEvent_DataReaderView (const CliffEvent_DataReaderView &);
                CliffEvent_DataReaderView & operator = (const CliffEvent_DataReaderView &);
            };
        }

    }

}

#endif
