#ifndef _H_B7EDC644B2DC97FFB50DBAEDFFF5D73C_KeyboardInput_DCPS_H_
#define _H_B7EDC644B2DC97FFB50DBAEDFFF5D73C_KeyboardInput_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "KeyboardInput_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class KeyboardInput_TypeSupportInterface;

            typedef KeyboardInput_TypeSupportInterface * KeyboardInput_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < KeyboardInput_TypeSupportInterface> KeyboardInput_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < KeyboardInput_TypeSupportInterface> KeyboardInput_TypeSupportInterface_out;


            class KeyboardInput_DataWriter;

            typedef KeyboardInput_DataWriter * KeyboardInput_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < KeyboardInput_DataWriter> KeyboardInput_DataWriter_var;
            typedef DDS_DCPSInterface_out < KeyboardInput_DataWriter> KeyboardInput_DataWriter_out;


            class KeyboardInput_DataReader;

            typedef KeyboardInput_DataReader * KeyboardInput_DataReader_ptr;
            typedef DDS_DCPSInterface_var < KeyboardInput_DataReader> KeyboardInput_DataReader_var;
            typedef DDS_DCPSInterface_out < KeyboardInput_DataReader> KeyboardInput_DataReader_out;


            class KeyboardInput_DataReaderView;

            typedef KeyboardInput_DataReaderView * KeyboardInput_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < KeyboardInput_DataReaderView> KeyboardInput_DataReaderView_var;
            typedef DDS_DCPSInterface_out < KeyboardInput_DataReaderView> KeyboardInput_DataReaderView_out;

            struct KeyboardInput_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < KeyboardInput_, struct KeyboardInput_Seq_uniq_> KeyboardInput_Seq;
            typedef DDS_DCPSSequence_var < KeyboardInput_Seq> KeyboardInput_Seq_var;
            typedef DDS_DCPSSequence_out < KeyboardInput_Seq> KeyboardInput_Seq_out;

            class  KeyboardInput_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef KeyboardInput_TypeSupportInterface_ptr _ptr_type;
                typedef KeyboardInput_TypeSupportInterface_var _var_type;

                static KeyboardInput_TypeSupportInterface_ptr _duplicate (KeyboardInput_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyboardInput_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static KeyboardInput_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyboardInput_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyboardInput_TypeSupportInterface_ptr _this () { return this; }


            protected:
                KeyboardInput_TypeSupportInterface () {};
                ~KeyboardInput_TypeSupportInterface () {};
            private:
                KeyboardInput_TypeSupportInterface (const KeyboardInput_TypeSupportInterface &);
                KeyboardInput_TypeSupportInterface & operator = (const KeyboardInput_TypeSupportInterface &);
            };

            class  KeyboardInput_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef KeyboardInput_DataWriter_ptr _ptr_type;
                typedef KeyboardInput_DataWriter_var _var_type;

                static KeyboardInput_DataWriter_ptr _duplicate (KeyboardInput_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyboardInput_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static KeyboardInput_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyboardInput_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyboardInput_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const KeyboardInput_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const KeyboardInput_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const KeyboardInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const KeyboardInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const KeyboardInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const KeyboardInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const KeyboardInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const KeyboardInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const KeyboardInput_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const KeyboardInput_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (KeyboardInput_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyboardInput_& instance_data) = 0;

            protected:
                KeyboardInput_DataWriter () {};
                ~KeyboardInput_DataWriter () {};
            private:
                KeyboardInput_DataWriter (const KeyboardInput_DataWriter &);
                KeyboardInput_DataWriter & operator = (const KeyboardInput_DataWriter &);
            };

            class  KeyboardInput_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef KeyboardInput_DataReader_ptr _ptr_type;
                typedef KeyboardInput_DataReader_var _var_type;

                static KeyboardInput_DataReader_ptr _duplicate (KeyboardInput_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyboardInput_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static KeyboardInput_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyboardInput_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyboardInput_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KeyboardInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KeyboardInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KeyboardInput_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyboardInput_& instance) = 0;

            protected:
                KeyboardInput_DataReader () {};
                ~KeyboardInput_DataReader () {};
            private:
                KeyboardInput_DataReader (const KeyboardInput_DataReader &);
                KeyboardInput_DataReader & operator = (const KeyboardInput_DataReader &);
            };

            class  KeyboardInput_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef KeyboardInput_DataReaderView_ptr _ptr_type;
                typedef KeyboardInput_DataReaderView_var _var_type;

                static KeyboardInput_DataReaderView_ptr _duplicate (KeyboardInput_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static KeyboardInput_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static KeyboardInput_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static KeyboardInput_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                KeyboardInput_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (KeyboardInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (KeyboardInput_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (KeyboardInput_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (KeyboardInput_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const KeyboardInput_& instance) = 0;

            protected:
                KeyboardInput_DataReaderView () {};
                ~KeyboardInput_DataReaderView () {};
            private:
                KeyboardInput_DataReaderView (const KeyboardInput_DataReaderView &);
                KeyboardInput_DataReaderView & operator = (const KeyboardInput_DataReaderView &);
            };
        }

    }

}

#endif
