#ifndef _H_F98D4B06D6A8067BCE0A4B6EFE1B444F_Led_DCPS_H_
#define _H_F98D4B06D6A8067BCE0A4B6EFE1B444F_Led_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Led_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class Led_TypeSupportInterface;

            typedef Led_TypeSupportInterface * Led_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Led_TypeSupportInterface> Led_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Led_TypeSupportInterface> Led_TypeSupportInterface_out;


            class Led_DataWriter;

            typedef Led_DataWriter * Led_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Led_DataWriter> Led_DataWriter_var;
            typedef DDS_DCPSInterface_out < Led_DataWriter> Led_DataWriter_out;


            class Led_DataReader;

            typedef Led_DataReader * Led_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Led_DataReader> Led_DataReader_var;
            typedef DDS_DCPSInterface_out < Led_DataReader> Led_DataReader_out;


            class Led_DataReaderView;

            typedef Led_DataReaderView * Led_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Led_DataReaderView> Led_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Led_DataReaderView> Led_DataReaderView_out;

            struct Led_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Led_, struct Led_Seq_uniq_> Led_Seq;
            typedef DDS_DCPSSequence_var < Led_Seq> Led_Seq_var;
            typedef DDS_DCPSSequence_out < Led_Seq> Led_Seq_out;

            class  Led_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Led_TypeSupportInterface_ptr _ptr_type;
                typedef Led_TypeSupportInterface_var _var_type;

                static Led_TypeSupportInterface_ptr _duplicate (Led_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Led_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Led_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Led_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Led_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Led_TypeSupportInterface () {};
                ~Led_TypeSupportInterface () {};
            private:
                Led_TypeSupportInterface (const Led_TypeSupportInterface &);
                Led_TypeSupportInterface & operator = (const Led_TypeSupportInterface &);
            };

            class  Led_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Led_DataWriter_ptr _ptr_type;
                typedef Led_DataWriter_var _var_type;

                static Led_DataWriter_ptr _duplicate (Led_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Led_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Led_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Led_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Led_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Led_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Led_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Led_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Led_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Led_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Led_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Led_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Led_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Led_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Led_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Led_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Led_& instance_data) = 0;

            protected:
                Led_DataWriter () {};
                ~Led_DataWriter () {};
            private:
                Led_DataWriter (const Led_DataWriter &);
                Led_DataWriter & operator = (const Led_DataWriter &);
            };

            class  Led_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Led_DataReader_ptr _ptr_type;
                typedef Led_DataReader_var _var_type;

                static Led_DataReader_ptr _duplicate (Led_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Led_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Led_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Led_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Led_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Led_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Led_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Led_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Led_& instance) = 0;

            protected:
                Led_DataReader () {};
                ~Led_DataReader () {};
            private:
                Led_DataReader (const Led_DataReader &);
                Led_DataReader & operator = (const Led_DataReader &);
            };

            class  Led_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Led_DataReaderView_ptr _ptr_type;
                typedef Led_DataReaderView_var _var_type;

                static Led_DataReaderView_ptr _duplicate (Led_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Led_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Led_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Led_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Led_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Led_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Led_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Led_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Led_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Led_& instance) = 0;

            protected:
                Led_DataReaderView () {};
                ~Led_DataReaderView () {};
            private:
                Led_DataReaderView (const Led_DataReaderView &);
                Led_DataReaderView & operator = (const Led_DataReaderView &);
            };
        }

    }

}

#endif
