#ifndef _H_4ECA17C6402DCDC0D5CB9FE357CF71B2_PowerSystemEvent_DCPS_H_
#define _H_4ECA17C6402DCDC0D5CB9FE357CF71B2_PowerSystemEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PowerSystemEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class PowerSystemEvent_TypeSupportInterface;

            typedef PowerSystemEvent_TypeSupportInterface * PowerSystemEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PowerSystemEvent_TypeSupportInterface> PowerSystemEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PowerSystemEvent_TypeSupportInterface> PowerSystemEvent_TypeSupportInterface_out;


            class PowerSystemEvent_DataWriter;

            typedef PowerSystemEvent_DataWriter * PowerSystemEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PowerSystemEvent_DataWriter> PowerSystemEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < PowerSystemEvent_DataWriter> PowerSystemEvent_DataWriter_out;


            class PowerSystemEvent_DataReader;

            typedef PowerSystemEvent_DataReader * PowerSystemEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PowerSystemEvent_DataReader> PowerSystemEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < PowerSystemEvent_DataReader> PowerSystemEvent_DataReader_out;


            class PowerSystemEvent_DataReaderView;

            typedef PowerSystemEvent_DataReaderView * PowerSystemEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PowerSystemEvent_DataReaderView> PowerSystemEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PowerSystemEvent_DataReaderView> PowerSystemEvent_DataReaderView_out;

            struct PowerSystemEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PowerSystemEvent_, struct PowerSystemEvent_Seq_uniq_> PowerSystemEvent_Seq;
            typedef DDS_DCPSSequence_var < PowerSystemEvent_Seq> PowerSystemEvent_Seq_var;
            typedef DDS_DCPSSequence_out < PowerSystemEvent_Seq> PowerSystemEvent_Seq_out;

            class  PowerSystemEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PowerSystemEvent_TypeSupportInterface_ptr _ptr_type;
                typedef PowerSystemEvent_TypeSupportInterface_var _var_type;

                static PowerSystemEvent_TypeSupportInterface_ptr _duplicate (PowerSystemEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerSystemEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerSystemEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PowerSystemEvent_TypeSupportInterface () {};
                ~PowerSystemEvent_TypeSupportInterface () {};
            private:
                PowerSystemEvent_TypeSupportInterface (const PowerSystemEvent_TypeSupportInterface &);
                PowerSystemEvent_TypeSupportInterface & operator = (const PowerSystemEvent_TypeSupportInterface &);
            };

            class  PowerSystemEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PowerSystemEvent_DataWriter_ptr _ptr_type;
                typedef PowerSystemEvent_DataWriter_var _var_type;

                static PowerSystemEvent_DataWriter_ptr _duplicate (PowerSystemEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerSystemEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerSystemEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PowerSystemEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PowerSystemEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PowerSystemEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PowerSystemEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PowerSystemEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PowerSystemEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PowerSystemEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PowerSystemEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PowerSystemEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PowerSystemEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PowerSystemEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerSystemEvent_& instance_data) = 0;

            protected:
                PowerSystemEvent_DataWriter () {};
                ~PowerSystemEvent_DataWriter () {};
            private:
                PowerSystemEvent_DataWriter (const PowerSystemEvent_DataWriter &);
                PowerSystemEvent_DataWriter & operator = (const PowerSystemEvent_DataWriter &);
            };

            class  PowerSystemEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PowerSystemEvent_DataReader_ptr _ptr_type;
                typedef PowerSystemEvent_DataReader_var _var_type;

                static PowerSystemEvent_DataReader_ptr _duplicate (PowerSystemEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerSystemEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerSystemEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PowerSystemEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PowerSystemEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PowerSystemEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerSystemEvent_& instance) = 0;

            protected:
                PowerSystemEvent_DataReader () {};
                ~PowerSystemEvent_DataReader () {};
            private:
                PowerSystemEvent_DataReader (const PowerSystemEvent_DataReader &);
                PowerSystemEvent_DataReader & operator = (const PowerSystemEvent_DataReader &);
            };

            class  PowerSystemEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PowerSystemEvent_DataReaderView_ptr _ptr_type;
                typedef PowerSystemEvent_DataReaderView_var _var_type;

                static PowerSystemEvent_DataReaderView_ptr _duplicate (PowerSystemEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PowerSystemEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PowerSystemEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PowerSystemEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PowerSystemEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PowerSystemEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PowerSystemEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PowerSystemEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PowerSystemEvent_& instance) = 0;

            protected:
                PowerSystemEvent_DataReaderView () {};
                ~PowerSystemEvent_DataReaderView () {};
            private:
                PowerSystemEvent_DataReaderView (const PowerSystemEvent_DataReaderView &);
                PowerSystemEvent_DataReaderView & operator = (const PowerSystemEvent_DataReaderView &);
            };
        }

    }

}

#endif
